Subject: Re: bug#38563: 27.0.50; Company popup renders with newlines (?) inheriting the bg properties of the character at next line's bol

From: Eli Zaretskii <[email-masked]>
Date: Fri, 13 Dec 2019 17:32:46 +0200

> Cc: [email-masked]
> From: Dmitry Gutov <[email-masked]>
> Date: Fri, 13 Dec 2019 17:04:21 +0200
> 
> On 13.12.2019 16:12, Eli Zaretskii wrote:
> 
> > It wouldn't have worked, because ':extend nil' means the face which
> > says this is ineligible for face merging when face extension is
> > considered.  IOW, ':extend nil' cannot countermand some other face
> > that's being merged which says ':extend t'.
> 
> Hmm, that's counter to my intuition how this should work (meaning, 
> :extend nil should be used during merging, like it's used during 
> inheritance), but maybe this way enables functionality that wouldn't be 
> possible otherwise.

':extend nil' is "used" during merging in the sense that such a face
is skipped when we want a face for extending past EOL.  How else could
we implement that?  Setting :extend to nil means that _none_ of the
other attributes of the face are to be taken into account for merging.

Inheritance just makes the inheriting face implicitly behave as if its
:extend attribute is the same as of the parent face, when the
inheriting face doesn't itself specify :extend, i.e. has it set to
'unspecified'.

> > The problem is that the company's tooltip faces don't say ':extend t',
> > so they are ineligible for merging when the face beyond EOL is
> > considered.
> 
> And we definitely wouldn't want the tooptil faces to say ':extend t'. Or 
> else it would not be rectangular.

Sure.

> > The only face which was eligible was the face of the
> > first character of the line where you place your overlay.  Even if it
> > doesn't have ':extend t', we treat the base face (the first one being
> > merged) specially: we always treat it as eligible (ever wondered how
> > come 'default', 'tool-bar', and other "basic" faces get extended
> > although they don't specify :extend?).
> 
> Um, okay. I suppose they have to be extended because we need to draw 
> *something* at the place "occupied by" newline.

Yes.